﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace PCRU01_Demo_Cs
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        [DllImport("pcru01.dll")]
        public static extern int OpenDevice();

        [DllImport("pcru01.dll")]
        public static extern int Calibrate();

        [DllImport("pcru01.dll")]
        public static extern void CloseDevice();

        [DllImport("pcru01.dll")]
        public static extern void StartRecording();

        [DllImport("pcru01.dll")]
        public static extern void StopRecording();

        [DllImport("pcru01.dll")]
        public static extern void ReadData(int[] Buffer);

        [DllImport("pcru01.dll")]
        public static extern void SetVoltageRange(int Channel, int Range);
         
        private void Button1_Click(object sender, EventArgs e)
        {
            if (OpenDevice() == 0)
            {
                Label9.Text = "PCRU01 connected";
                GroupBox1.Enabled = true;
            }
            else
            {
                Label9.Text = "PCRU01 not found";
                GroupBox1.Enabled = false;
            }
        }

        private void Button2_Click(object sender, EventArgs e)
        {
            int h = Calibrate();
            switch (h) 
            {
            case  0: Label9.Text = "PCRU01 calibrated";
                break;
            case  -1: Label9.Text = "PCRU01 calibration cancelled";
                break;
            case  -2: Label9.Text = "PCRU01 calibration failed";
                break;
            }
            ComboBox1.SelectedIndex = 0;
            ComboBox2.SelectedIndex = 0;
            ComboBox3.SelectedIndex = 0;
            ComboBox4.SelectedIndex = 0;
        }

        private void Button3_Click(object sender, EventArgs e)
        {
            StopRecording();
            CloseDevice();
            Label9.Text = "PCRU01 closed";
            GroupBox1.Enabled = false;
        }

        private void Button4_Click(object sender, EventArgs e)
        {
            StartRecording();
        }

        private void Button5_Click(object sender, EventArgs e)
        {
            int i, j;
            string Line;
            int[] tmpBuffer = new int[10];
            int[] DataBuffer = new int[100];

            for (i=0; i<15; i++)
            {
                ReadData(tmpBuffer);
                for (j=0; j<6; j++)
                    DataBuffer[i*6 + j] = tmpBuffer[j];
            }

            ListBox1.Items.Clear();

            for (i=0; i<15; i++)
            {
                Line = "";
                for (j=0; j<6; j++)
                    Line = Line + DataBuffer[i*6 + j] ;
            }

            for (i=0; i<15; i++)
            {
                Line = "";
                for (j = 0; j < 6; j++)
                    Line = Line + DataBuffer[i * 6 + j].ToString() + (char)(9);
                ListBox1.Items.Add(Line);
            }
        }

        private void Button6_Click(object sender, EventArgs e)
        {
            StopRecording();
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            StopRecording();
            CloseDevice();
        }

        private void ComboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetVoltageRange(1, ComboBox1.SelectedIndex + 1);
        }

        private void ComboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetVoltageRange(2, ComboBox2.SelectedIndex + 1);
        }

        private void ComboBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetVoltageRange(3, ComboBox3.SelectedIndex + 1);
        }

        private void ComboBox4_SelectedIndexChanged(object sender, EventArgs e)
        {
            SetVoltageRange(4, ComboBox4.SelectedIndex + 1);
        }
    }
}
