unit PCRU01;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Start_Recording: TButton;
    GroupBox1: TGroupBox;
    RadioGroup1: TRadioGroup;
    Memo1: TMemo;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Open: TButton;
    Read_Data: TButton;
    Stop_Recording: TButton;
    Close: TButton;
    RadioGroup2: TRadioGroup;
    RadioGroup3: TRadioGroup;
    RadioGroup4: TRadioGroup;
    Label8: TLabel;
    Calibrate_: TButton;
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure RadioGroup3Click(Sender: TObject);
    procedure RadioGroup4Click(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure CloseClick(Sender: TObject);
    procedure Start_RecordingClick(Sender: TObject);
    procedure Stop_RecordingClick(Sender: TObject);
    procedure Read_DataClick(Sender: TObject);
    procedure Calibrate_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  DataRead: ARRAY[0..7] OF Integer;

implementation

{$R *.DFM}

function OpenDevice: integer; stdcall; external 'PCRU01.dll';
function Calibrate: integer; stdcall; external 'PCRU01.dll';
procedure CloseDevice; stdcall; external 'PCRU01.dll';
PROCEDURE StartRecording; stdcall; external 'PCRU01.dll';
PROCEDURE StopRecording; stdcall; external 'PCRU01.dll';
PROCEDURE ReadData(Buffer:Pointer); stdcall; external 'PCRU01.dll';
PROCEDURE SetVoltageRange(Channel: Integer ; Gain: Integer); stdcall; external 'PCRU01.dll';



procedure TForm1.OpenClick(Sender: TObject);
begin
  if OpenDevice = 0 then
    Label8.caption:='PCRU01 connected'
  else
    Label8.caption:='PCRU01 not found';
end;

procedure TForm1.CloseClick(Sender: TObject);
begin
  StopRecording;
  CloseDevice;
  Label8.caption:='PCRU01 closed';
end;

procedure TForm1.Start_RecordingClick(Sender: TObject);
begin
  StartRecording;
end;

procedure TForm1.Stop_RecordingClick(Sender: TObject);
begin
  StopRecording;
end;

procedure TForm1.Read_DataClick(Sender: TObject);
var p:pointer;
i,j:integer;
s:string;
tmp: array [0..200] of integer;
begin
  memo1.clear;
  for j:=0 to 20 do
  begin
    p:=@DataRead;
    ReadData(p);
    for i:=0 to 5 do tmp[j*6+i]:=DataRead[i];
  end;
  for j:=0 to 20 do
  begin
    s:='';                                                    
    for i:=0 to 5 do s:=s +inttostr(tmp[j*6+i])+chr(9);
    memo1.lines.add(s);
  end;
end;

procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  case RadioGroup1.itemindex of
    0: SetVoltageRange(1,1);
    1: SetVoltageRange(1,2);
    2: SetVoltageRange(1,3);
    3: SetVoltageRange(1,4);
    4: SetVoltageRange(1,5);
    5: SetVoltageRange(1,6);
  end;
end;

procedure TForm1.RadioGroup2Click(Sender: TObject);
begin
  case RadioGroup2.itemindex of
    0: SetVoltageRange(2,1);
    1: SetVoltageRange(2,2);
    2: SetVoltageRange(2,3);
    3: SetVoltageRange(2,4);
    4: SetVoltageRange(2,5);
    5: SetVoltageRange(2,6);
  end;
end;

procedure TForm1.RadioGroup3Click(Sender: TObject);
begin
  case RadioGroup3.itemindex of
    0: SetVoltageRange(3,1);
    1: SetVoltageRange(3,2);
    2: SetVoltageRange(3,3);
    3: SetVoltageRange(3,4);
    4: SetVoltageRange(3,5);
    5: SetVoltageRange(3,6);
  end;
end;

procedure TForm1.RadioGroup4Click(Sender: TObject);
begin
  case RadioGroup4.itemindex of
    0: SetVoltageRange(4,1);
    1: SetVoltageRange(4,2);
    2: SetVoltageRange(4,3);
    3: SetVoltageRange(4,4);
    4: SetVoltageRange(4,5);
    5: SetVoltageRange(4,6);
  end;
end;

procedure TForm1.Calibrate_Click(Sender: TObject);
var h:integer;
begin
  h:=Calibrate;
  case h of
    0:  Label8.caption:='PCRU01 calibrated';
    -1: Label8.caption:='PCRU01 calibration cancelled';
    -2: Label8.caption:='PCRU01 calibration failed';
  end;
  RadioGroup1.itemindex:=0;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  StopRecording;
  CloseDevice;
end;

end.
