﻿Public Class Form1
    'Declare use of the DLL
    Private Declare Function OpenDevice Lib "pcru01.dll" () As Integer
    Private Declare Function Calibrate Lib "pcru01.dll" () As Integer
    Private Declare Sub CloseDevice Lib "pcru01.dll" ()
    Private Declare Sub StartRecording Lib "pcru01.dll" ()
    Private Declare Sub StopRecording Lib "pcru01.dll" ()
    Private Declare Sub ReadData Lib "pcru01.dll" (ByRef ArrayPointer As Integer)
    Private Declare Sub SetVoltageRange Lib "pcru01.dll" (ByVal Channel As Integer, ByVal Range As Integer)

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If OpenDevice() = 0 Then
            Label9.Text = "PCRU01 connected"
            GroupBox1.Enabled = True
        Else
            Label9.Text = "PCRU01 not found"
            GroupBox1.Enabled = False
        End If
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        Dim h As Integer
        h = Calibrate()
        Select Case h
            Case 0
                Label9.Text = "PCRU01 calibrated"
            Case -1
                Label9.Text = "PCRU01 calibration cancelled"
            Case -2
                Label9.Text = "PCRU01 calibration failed"
        End Select
        ComboBox1.SelectedIndex = 0
        ComboBox2.SelectedIndex = 0
        ComboBox3.SelectedIndex = 0
        ComboBox4.SelectedIndex = 0
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        StopRecording()
        CloseDevice()
        Label9.Text = "PCRU01 closed"
        GroupBox1.Enabled = False
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        StartRecording()
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim DataBuffer(0 To 100) As Integer
        Dim Line As String
        Dim i, j As Integer
        For i = 0 To 14
            ReadData(DataBuffer(i * 6))
        Next
        ListBox1.Items.Clear()
        For i = 0 To 14
            Line = ""
            For j = 0 To 5
                Line = Line + Str(DataBuffer(i * 6 + j)) + Chr(9)
            Next
            ListBox1.Items.Add(Line)
        Next
    End Sub
    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        StopRecording()
    End Sub

    Private Sub ComboBox1_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox1.SelectedIndexChanged
        SetVoltageRange(1, ComboBox1.SelectedIndex + 1)
    End Sub

    Private Sub ComboBox2_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox2.SelectedIndexChanged
        SetVoltageRange(2, ComboBox2.SelectedIndex + 1)
    End Sub

    Private Sub ComboBox3_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox3.SelectedIndexChanged
        SetVoltageRange(3, ComboBox3.SelectedIndex + 1)
    End Sub

    Private Sub ComboBox4_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBox4.SelectedIndexChanged
        SetVoltageRange(4, ComboBox4.SelectedIndex + 1)
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        StopRecording()
        CloseDevice()
    End Sub
End Class
